05efa0e408d66bce1520fc2b108368a39c33aabe
[xfstests-dev.git] / 021
1 #! /bin/sh
2 # XFS QA Test No. 021
3 # $Id: 1.1 $
4 #
5 # xfs_db type attr test (pv 797508 linux-xfs & IRIX)
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
9
10 # This program is free software; you can redistribute it and/or modify it
11 # under the terms of version 2 of the GNU General Public License as
12 # published by the Free Software Foundation.
13
14 # This program is distributed in the hope that it would be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
17
18 # Further, this software is distributed without any warranty that it is
19 # free of the rightful claim of any third person regarding infringement
20 # or the like.  Any license provided herein, whether implied or
21 # otherwise, applies only to this software file.  Patent licenses, if
22 # any, provided herein do not apply to combinations of this program with
23 # other software, or any other product whatsoever.
24
25 # You should have received a copy of the GNU General Public License along
26 # with this program; if not, write the Free Software Foundation, Inc., 59
27 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
28
29 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
30 # Mountain View, CA  94043, or:
31
32 # http://www.sgi.com 
33
34 # For further information regarding this notice, see: 
35
36 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
37 #-----------------------------------------------------------------------
38 #
39 # creator
40 owner=dxm@sgi.com
41
42 seq=`basename $0`
43 echo "QA output created by $seq"
44
45 here=`pwd`
46 tmp=/tmp/$$
47 status=0        # success is the default!
48 # get standard environment, filters and checks
49 . ./common.rc
50 . ./common.filter
51
52 _cleanup()
53 {
54     echo "*** unmount"
55     umount $SCRATCH_MNT 2>/dev/null
56     rm -f $tmp.*
57 }
58 trap "_cleanup; exit \$status" 0 1 2 3 15
59
60 _s()
61 {
62     echo $2 | attr -s $1 $testfile >/dev/null
63 }
64
65 _attr()
66 {
67     attr $* 2>$tmp.err >$tmp.out
68     exit=$?
69     sed "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;" $tmp.out
70     sed "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;" $tmp.err 1>&2
71     return $exit
72 }
73
74 _getfattr()
75 {
76     getfattr $* 2>$tmp.err >$tmp.out
77     exit=$?
78     sed "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;" $tmp.out
79     sed "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;" $tmp.err 1>&2
80     return $exit
81 }
82
83 _filter_xfsdb2()
84 {
85         sed -e 
86 }
87
88 # real QA test starts here
89 _require_scratch
90
91 rm -f $seq.full
92 umount $SCRATCH_DEV >/dev/null 2>&1
93
94 echo "*** mkfs"
95 mkfs_xfs $SCRATCH_DEV >/dev/null \
96     || _fail "mkfs failed"
97   
98 echo "*** mount FS"
99 mount -t xfs $SCRATCH_DEV $SCRATCH_MNT >/dev/null \
100     || _fail "mount failed"
101     
102 testfile=$SCRATCH_MNT/testfile
103 echo "*** make test file 1"
104
105 touch $testfile.1
106 echo "v1" | _attr -s "a1" $testfile.1 >/dev/null
107 echo "v2--" | _attr -s "a2--" $testfile.1 >/dev/null
108 _getfattr --absolute-names $testfile.1
109 inum_1=`ls -li $testfile.1 | $AWK_PROG '{ print $1 }'`
110
111 echo "*** make test file 2"
112
113 touch $testfile.2
114 echo "value_1" | _attr -s "a1" $testfile.2 >/dev/null
115 echo "value_2" | _attr -s "a2-----" $testfile.2 >/dev/null
116 ( echo start ; dd if=/dev/zero bs=65525 count=1 ; echo end ) \
117     | _attr -s "a3" $testfile.2 >/dev/null
118 _getfattr --absolute-names $testfile.2
119
120 # print name and size from 1st line of output
121 _attr -g "a3" $testfile.2 | head -1
122
123 # print out the rest of the data apart from the header
124 # the size is +1 for an extra \n at the end
125 echo -n "size of attr value = "
126 _attr -g "a3" $testfile.2 | tail -3 | wc -c
127 echo ""
128
129 inum_2=`ls -li $testfile.2 | $AWK_PROG '{ print $1 }'`
130     
131 echo "*** unmount FS"
132 umount $SCRATCH_DEV >>$seq.full 2>&1 \
133     || _fail "umount failed"
134     
135 echo "*** dump attributes (1)"
136
137 xfs_db -r -c "inode $inum_1" -c "print a.sfattr" $SCRATCH_DEV
138
139 echo "*** dump attributes (2)"
140
141 xfs_db -r -c "inode $inum_2" -c "a a.bmx[0].startblock" -c print $SCRATCH_DEV \
142     | perl -ne '
143 s/^(hdr.firstused =) (\d+)/\1 FIRSTUSED/;
144 s/^(hdr.freemap\[0-2] = \[base,size]).*/\1 [FREEMAP..]/;
145 s/^(entries\[0-2] = \[hashval,nameidx,incomplete,root,local]).*/\1 [ENTRIES..]/;
146     print;'
147
148 echo "*** done"
149 exit